﻿using Infragistics.Win.DataVisualization;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            var data = new EnergyDataSource();

            var xAxis = new CategoryXAxis
            {
                Label = "Label",
                DataSource = data
            };
            ultraDataChart1.Axes.Add(xAxis);

            var yAxis = new NumericYAxis();
            ultraDataChart1.Axes.Add(yAxis);

            LineSeries series1 = new LineSeries();
            series1.XAxis = xAxis;
            series1.YAxis = yAxis;
            series1.ValueMemberPath = "Coal";
            series1.DataSource = data;
            series1.ShowDefaultTooltip = true;
            ultraDataChart1.Series.Add(series1);

            LineSeries series2 = new LineSeries();
            series2.XAxis = xAxis;
            series2.YAxis = yAxis;
            series2.ValueMemberPath = "Oil";
            series2.DataSource = data;
            series2.ShowDefaultTooltip = true;
            ultraDataChart1.Series.Add(series2);

            LineSeries series3 = new LineSeries();
            series3.XAxis = xAxis;
            series3.YAxis = yAxis;
            series3.ValueMemberPath = "Gas";
            series3.DataSource = data;
            series3.ShowDefaultTooltip = true;
            ultraDataChart1.Series.Add(series3);

            LineSeries series4 = new LineSeries();
            series4.XAxis = xAxis;
            series4.YAxis = yAxis;
            series4.ValueMemberPath = "Nuclear";
            series4.DataSource = data;
            series4.ShowDefaultTooltip = true;
            ultraDataChart1.Series.Add(series4);

            ItemToolTipLayer tooltipLayer = new ItemToolTipLayer();
            ultraDataChart1.Series.Add(tooltipLayer);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var data = new EnergyDataSource2();

            (ultraDataChart1.Axes[0] as CategoryXAxis).DataSource = data;

            foreach(Series series in ultraDataChart1.Series)
            {
                if(series is LineSeries)
                {
                    series.DataSource = data;
                }
            }
        }
    }

    public class EnergyDataSource : List<EnergyProduction>
    {
        public EnergyDataSource()
        {
            this.Add(new EnergyProduction { Region = "America", Country = "CAN", Coal = 400, Oil = 100, Gas = 175, Nuclear = 225 });
            this.Add(new EnergyProduction { Region = "Asia", Country = "CHN", Coal = 925, Oil = 200, Gas = 350, Nuclear = 400 });
            this.Add(new EnergyProduction { Region = "Europe", Country = "RUS", Coal = 550, Oil = 200, Gas = 250, Nuclear = 475 });
            this.Add(new EnergyProduction { Region = "Asia", Country = "AUS", Coal = 450, Oil = 100, Gas = 150, Nuclear = 175 });
            this.Add(new EnergyProduction { Region = "America", Country = "USA", Coal = 800, Oil = 250, Gas = 475, Nuclear = 575 });
            this.Add(new EnergyProduction { Region = "Europe", Country = "FRA", Coal = 375, Oil = 150, Gas = 350, Nuclear = 275 });
        }
    }

    public class EnergyDataSource2 : List<EnergyProduction>
    {
        public EnergyDataSource2()
        {
            this.Add(new EnergyProduction { Region = "America", Country = "CAN", Coal = 234, Oil = 254, Gas = 643, Nuclear = 265 });
            this.Add(new EnergyProduction { Region = "Asia", Country = "CHN", Coal = 235, Oil = 354, Gas = 645, Nuclear = 645 });
            this.Add(new EnergyProduction { Region = "Europe", Country = "RUS", Coal = 87, Oil = 754, Gas = 353, Nuclear = 344 });
            this.Add(new EnergyProduction { Region = "Asia", Country = "AUS", Coal = 245, Oil = 565, Gas = 363, Nuclear = 335 });
            this.Add(new EnergyProduction { Region = "America", Country = "USA", Coal = 475, Oil = 234, Gas = 643, Nuclear = 345 });
            this.Add(new EnergyProduction { Region = "Europe", Country = "FRA", Coal = 376, Oil = 863, Gas = 254, Nuclear = 343 });
        }
    }

    public class EnergyProduction
    {
        public string Country { get; set; }
        public string Region { get; set; }
        public string Year { get; set; }

        public double Nuclear { get; set; }
        public double Coal { get; set; }
        public double Oil { get; set; }
        public double Gas { get; set; }
    }
}
